Package: org.codehaus.groovy.runtime.metaclass

## [Java] Class NewMetaMethod

- org.codehaus.groovy.runtime.metaclass.NewMetaMethod

-     public class NewMetaMethod
      extends ReflectionMetaMethod

  Base class for NewInstanceMetaMethod and NewStaticMetaMethod

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected static CachedClass[]` | `EMPTY_TYPE_ARRAY` | Empty array of cached classes used as default
    `protected CachedClass[]` | `bytecodeParameterTypes` | The parameter types from the bytecode (including the first parameter which is the class)

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class ReflectionMetaMethod` | `method`
    `class MetaMethod` | `EMPTY_ARRAY`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `NewMetaMethod(CachedMethod method)` Constructs a new NewMetaMethod.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public CachedClass[]` | `getBytecodeParameterTypes()` Gets the bytecode parameter types (including the first parameter which is the class).
    `` | `public CachedClass` | `getDeclaringClass()`
    `` | `public CachedClass` | `getOwnerClass()` Gets the owner class (the first bytecode parameter type).

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ReflectionMetaMethod` | `getCachedMethod, getDeclaringClass, getModifiers, getName, getPT, getReturnType, invoke, toString`
    `class MetaMethod` | `checkParameters, clone, doMethodInvoke, equal, equal, getDeclaringClass, getDescriptor, getModifiers, getMopName, getName, getReturnType, getSignature, invoke, isAbstract, isCacheable, isDefault, isMethod, isSame, processDoMethodInvokeException, toString`
    `class ParameterTypes` | `coerceArgumentsToClasses, correctArguments, getNativeParameterTypes, getPT, getParameterTypes, isValidExactMethod, isValidExactMethod, isValidMethod, isValidMethod, isVargsMethod, isVargsMethod, setParametersTypes`

- - ### Field Detail

    - #### protected static final CachedClass[] EMPTY_TYPE_ARRAY

      Empty array of cached classes used as default

    - #### protected CachedClass[] bytecodeParameterTypes

      The parameter types from the bytecode (including the first parameter which is the class)

  - ### Constructor Detail

    - #### public NewMetaMethod(CachedMethod method)

      Constructs a new NewMetaMethod.

      Parameters:
        `method` - the cached method

  - ### Method Detail

    - #### public CachedClass[] getBytecodeParameterTypes()

      Gets the bytecode parameter types (including the first parameter which is the class).

      Returns:
        the bytecode parameter types

    - #### public CachedClass getDeclaringClass()

    - #### public CachedClass getOwnerClass()

      Gets the owner class (the first bytecode parameter type).

      Returns:
        the owner class